;; SendLine.scm
;;
;; Use:
;;  % java -cp lib/jscheme.jar jscheme.REPL src/groupscheme/kernel/SendLine.scm
;;  > (send-line "www.google.com" 80 "GET / HTTP/1.0\n\n")
;;
;;
;; (send-line host port msg)
;;
;; This is a telnet-like interface that lets you send some lines
;; to a host/port and read one line, after which the socket is closed.
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(define (send-line host port msg)
   (let* (
          (buf (Array.newInstance char.class 10000))
          (s (java.net.Socket. host port))
          (theport (.getLocalPort s))
          (in (java.io.BufferedReader.
               (java.io.InputStreamReader. 
                (.getInputStream s))))
          (out (java.io.PrintStream.
                (.getOutputStream s))))
     (.println out msg)
     (.flush out)

;     (let ((x (.readLine in)))
;       (.close s)
;       x)))


  (let* (
         (n (.read in buf 0 10000))
         (st (String. buf 0 n))
         (x  (string->expr st)))
       (.close s)
       x)))

(define (http-read url-string)
   ;; this reads a string from a given url
   (define url (java.net.URL. url-string))
   (define http-con (.openConnection url))
   (define buf (java.lang.reflect.Array.newInstance char.class 65536))
   (define (drain-from-in in) ;; read input lines into a list in reverse order
    (let loop ((n (.read in buf 0 65535)) 
               (L ()))
         (if (equal? n -1)
             L
             (let ((z (java.lang.String. buf 0 n)))
               (loop (.read in buf 0 65535) (cons z L))))))
   (define (old-drain-from-in in) ;; read input lines into a list in reverse order
    (let loop ((x (.readLine in)) 
               (L ()))
         (write (list "read" x))(newline)
         (if (equal? x #null)
             L
             (loop (.readLine in) (cons x L)))))
   (define (strip-out-header L) ; L is a reversed list of lines from an http file
       (let loop ((L L) (R ()))
         (cond ((null? L) R)
               ((equal? (first L) "") R)
               (else (loop (rest L) (cons (first L) R))))))

   (define (list->string L)
     (let loop ((L L) (z (java.lang.StringBuffer.)))
          (if (null? L) 
              (.toString z)
              (loop (rest L) (.append (.append z (first L)) "\n")))))

   (let (
          (in (java.io.BufferedReader.
               (java.io.InputStreamReader. 
                (.getInputStream http-con)))))
     (let* ((result (drain-from-in in)))
        (.disconnect http-con)
        (list->string (strip-out-header result))
    )))



