;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
{
 GrewpEdit.scm

 Authors: Tim Hickey and Kenroy Granville
 License: LGPL, 
 Website: http://groupscheme.sourceforge.net/
 Purpose: 
   GrewpEdit is a program which demonstrates the groupscheme
   library. It provides a mechanism for users to meet, chat,
   and jointly edit files.
}
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Create the start pane
;
; here we create a window (mainwin) containing a JTabbedPane (JT)
; and we put in a registration window 
;
; The users specifies the host/port of the registrar
;
; Then the user can decide to join or create a GREWP
; specified by the host/port; after which the start 
; tab is removed and replaced by new JTabbedPane whic 
; contains JList with all the connected users and JList 
; of sessions that the user can join or create new
; sessions that will then appear in the list. 
;
; Each session generates a new JTabbedPane element
; The JTabbedPanes will display information about their
; group and the members in it....
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(environment-import "groupscheme/platform/RendezvousPanel.scm" "RP:")
(environment-import "jlib/Swing.scm")

(define (new-grewp-edit)

  (define GEversion "GrewpEdit Beta 1.1a ---- 3/31/05")
  (define JT (javax.swing.JTabbedPane.))
  (define network-win (window GEversion (grid 1 1 JT)))
  
  (define show-rendezvous-win
    (let ((pane (RP:make-rendezvous-panel JT network-win)))
      ;; (javax.swing.UIManager.setLookAndFeel 
      ;;   (javax.swing.UIManager.getSystemLookAndFeelClassName))
      (.add JT "Login" pane)
      (.setSelectedComponent JT pane)
      (.setDefaultCloseOperation network-win javax.swing.JFrame.EXIT_ON_CLOSE$)

      (.pack network-win)
      (.show network-win)
      network-win
  )) ;;close let/define
)
