;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
{
 GrewpChat.scm

}
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(environment-import "groupscheme/platform/util/FileUtil.scm" "FileU:")
(environment-import "groupscheme/platform/util/Menu.scm" "Menu:")
(environment-import "groupscheme/platform/util/Util.scm" "U:")
(environment-import "groupscheme/platform/GS/GroupClient.scm" "GC:")
(environment-import "groupscheme/platform/GS/GroupChat.scm" "GChat:")
(environment-import "groupscheme/platform/grewplet/MemberList.scm" "ML:")
(environment-import "jlib/Swing.scm")

(define (make-chat-panel RGC usercolor grewpname pw mainwin JT)
  (define user (RGC 'get 'name))
  (define host (first (RGC 'get 'address)))
  (define port (second (RGC 'get 'address)))
  (define G (GC:make-group-client user grewpname host port pw))
  (define GChat (GChat:make-p2p-group-chat 'name user 'color usercolor 
					   'mode 'gui))
  (define member-panel
    (ML:make-member-list-panel G usercolor
     (lambda(c)
       (.setBackground (GChat 'get 'chatarea) c)
       (GChat 'set 'color c))
     (lambda(x) (display x))
     (lambda(e) (.setSelectedIndex (.getSource e) -1))))

  (define (make-menu parent TA)
    (let* ((fmenu (menu "File"))
	   (emenu (menu "Edit"))
	   (pmenu (javax.swing.JPopupMenu. "Popup"))
	   (fhandler (FileU:makeFileHandler parent TA))
	   (close-action
	    (lambda()
	      (G 'logout)
	      (RGC 'send 'rollcall)
	      (.remove JT (.getSelectedComponent JT))))
	  );;close let defs
      ;;File Menu
      (.add fmenu (menuitem "Save..." (action (lambda (e) (fhandler 'save-as)))
			    (lambda(this) (.setMnemonic this #'S'))))
      (.addSeparator fmenu)
      (.add fmenu (menuitem "Close" (action (lambda (e) (close-action)))
			    (lambda(this) (.setMnemonic this #'C'))))
      ;;Edit Menu
      (Menu:addEditMenuItems emenu TA)
      ;;Popup Menu
      (Menu:addEditMenuItems pmenu TA)
      (Menu:addPopupMenu pmenu TA)

      (menubar fmenu emenu
	(row 'none 'center 
	     (label {Grewp Chat for [user] on [host]:[port]})))))

  (define the-panel
    (border
      (north (make-menu mainwin (GChat 'get 'chatarea)))
      (center (hsplit 0.2 member-panel
		          (GChat 'get 'panel)))))


  (G 'add-socket-closure-hook (lambda R 
     (U:error {[{<html>}
		{Your connection between '[grewpname]' and the server<br>}
		{has died! You can save your chat, but you can't chat<br>}
		{anymore.</html>}]}
	      the-panel)))

  (U:grewp-chat-setup G GChat usercolor
     {*** Welcome to the Chat space for [grewpname]\n})

  the-panel
 )


(define (grewplet cmd . R)
  (case cmd
    ((name) "GrewpChat")
    ((gui) (apply make-chat-panel R))))