{
 MemberList.scm

}

(environment-import "groupscheme/platform/GS/GroupClient.scm" "GC:")
(environment-import "groupscheme/platform/util/Util.scm" "U:")
(environment-import "jlib/Swing.scm")


(define (make-member-list-panel G ucolor ucolorproc
				callbackproc doubleclickproc)
  (letrec
     ((user (G 'get 'name))
      (T (maketagger))
      (ucolortag (lambda R (tryCatch (apply T R) (lambda(e) white))))
      ;; a button for changing usercolor with JColorChooser
      (cbutton
       (U:colorbutton "Change Color" ucolor
	  (lambda (e)
	    (set! ucolor (javax.swing.JColorChooser.showDialog 
			  the-panel "Pick your user color" ucolor))
	    (if (not (.isInstance java.awt.Color.class ucolor))
		(set! ucolor (.getBackground (.getSource e)))
		(begin (.setBackground (.getSource e) ucolor)
		       (G 'send 'ML-color-update 'request
			  user (U:colortransform ucolor))
		       (ucolorproc ucolor))))))
      ;; the jlist that contains the users
      (memberlist
       (U:rendered-jlist (G 'get 'users-in-my-group)
	 ;; a jlist CellRenderer procedure that returns a label 
	 ;; colored according to usercolor
	 (lambda (jlist value index isSelected cellHasFocus)
	   (label value (ucolortag value)
	      (lambda (this) (.setOpaque this #t)
		(if isSelected
		    (.setBorder this
		       (javax.swing.BorderFactory.createLoweredBevelBorder))
		    (.setBorder this 
		       (javax.swing.BorderFactory.createRaisedBevelBorder))))))
	 callbackproc)) ;;jlist selection call back procedure
      ;; this updates the memberlist
      (refresh (lambda()
		 (jlistwrite memberlist (G 'get 'users-in-my-group))
		 (.validate memberlist)))
      ;; THE GUI
      (the-panel
       (border
	(north 
	 (label "MEMBERS" (lambda(L) 
	   (.setFont L (.deriveFont (.getFont L)
		          (+ java.awt.Font.BOLD$ java.awt.Font.ITALIC$)))
	   (.setHorizontalAlignment L javax.swing.SwingConstants.CENTER$))))
	(center (scrollpane memberlist))
	(south cbutton)))
     );;close letrec definitions
     
    ;;This listener handles color updates
    (G 'add-listener 'ML-color-update
      (lambda(cmd handle _user rgba)
	(case handle
	  ((request)
	   (ucolortag _user (U:colortransform rgba))
	   (G 'send 'ML-color-update 'response user (U:colortransform ucolor)))
	  ((response)
	   (ucolortag _user (U:colortransform rgba))))
	(refresh)))

    ;;listen for all incoming and outgoing users
    (G 'add-listener 'GROUPSERVER
      (lambda (cmd . R)
	(case (first R)
	  ((newuser userleft) (refresh)))))

    ;;Send a request to load previous user colors
    (G 'send 'ML-color-update 'request user (U:colortransform ucolor))    
    (U:add-multi-click memberlist doubleclickproc 2)
    the-panel
  )
)


(define (grewplet cmd . R) ;; R ==> (RGC usercolor name pw mainwin JT)
  (case cmd
    ((name) "MemberList")
    ((gui)
     (let* ((RGC (first R))
	    (ucolor (second R))
	    (gpname (third R))
	    (pw (fourth R))
	    (user (RGC 'get 'name))
	    (host (first (RGC 'get 'address)))
	    (port (second (RGC 'get 'address)))
	    (G (GC:make-group-client user gpname host port pw)))
 
       (make-member-list-panel G ucolor
	(lambda(c) (display (U:colortransform c)))
	(lambda(x) (display x))
	(lambda(e) (display (.getSource e))))))
  )
)

