(environment-import "jlib/Swing.scm")

(define static-save
  (let ((sFC (javax.swing.JFileChooser.)))
    (lambda(sTA)
      (tryCatch
       (let* ((save? (= (.showSaveDialog sFC sTA)
			javax.swing.JFileChooser.APPROVE_OPTION$))
	      (chars (if save? 
			 (java.io.BufferedReader. 
			  (java.io.StringReader. (.getText sTA)))))
	      (outfile (if save?
			   (java.io.PrintWriter. 
			    (java.io.FileWriter. 
			     (java.io.File.
			      (.getCurrentDirectory sFC)
			      (.getName (.getSelectedFile sFC))))))))
	 ;; read lines from chars and write them to outfile...
	 (if save?
	     (let loop ((x (.readLine chars)))
	       (if (equal? #null x) 
		   (begin (.close outfile) (.close chars))
		   (begin (.println outfile x) (loop (.readLine chars)))))))
      (lambda(err) (display (list "error" err))(newline) #t)))))

;; R ==> (xtra-proc)
(define (makeFileHandler parent TA . R)
  (letrec
    ((extra-proc (if (>= (length R) 1) (first R) (lambda R #t)))
     (fc (javax.swing.JFileChooser.))
     (current_file null)
     (readStreamIntoString
      (lambda (stream) 
	(begin 
	  (define reader  
	    (java.io.BufferedReader. stream))
	  (define (readloop sb) 
	    (let ((x (.readLine reader))) 
	      (if (equal? #null x) sb 
		  (readloop  
		   (.append  
		    (.append sb x)  
		    "\n"))))) 
	  (.toString (readloop (java.lang.StringBuffer. 8192))))))

     (save
      (lambda()
	(tryCatch 
	 (begin
	   (let ((chars (java.io.BufferedReader. 
			 (java.io.StringReader. (.getText TA))))
		 (outfile (java.io.PrintWriter. 
			   (java.io.FileWriter. 
			    (set! current_file
			      (java.io.File.
				(.getCurrentDirectory fc)
				(.getName (.getSelectedFile fc))))))))
	     ;; ADD TEMP LAMBDA EXECUTION
	     (extra-proc current_file)
	     ;; here we need to read lines from chars and write them to outfile...
	     ;;(.write outfile chars 0 (.length chars))
	     (let loop ((x (.readLine chars)))
	       (if (equal? #null x) 
		   (begin (.close outfile) (.close chars))
		   (begin (.println outfile x) (loop (.readLine chars)))))))
	 (lambda(err) (display (list "error" err))(newline) #t))))

     (careful-save
      (lambda ()
	(if (or (equal? #null (.getSelectedFile fc))
		;;this might need to be check with directory or
		;;just end name of the file not the whole path+name or not needed at all
		(equal? "" (.getSelectedFile fc)))
	    (if (= (.showSaveDialog fc parent)
		   javax.swing.JFileChooser.APPROVE_OPTION$)
		(save))
	    (if (and (not (equal? (.getSelectedFile fc) #null))
		     (equal? javax.swing.JOptionPane.OK_OPTION$
			     (javax.swing.JOptionPane.showConfirmDialog 
			      parent
			      (string-append "Save to local file:\n     "
				      (.getSelectedFile fc) " ???")
			      "Save"
			      javax.swing.JOptionPane.YES_NO_OPTION$)))
		(save)
		(javax.swing.JOptionPane.showMessageDialog
		 parent "File not saved")))))

     (save-as
      (lambda ()
	(if (= (.showSaveDialog fc parent)
	       javax.swing.JFileChooser.APPROVE_OPTION$)
	      (save))))

     (new 
      (lambda () (.setText TA "") (.setSelectedFile fc #null)))

     (open 
      (lambda ()
	(tryCatch 
	 (begin 
	   (if (= (.showOpenDialog fc parent)
		  javax.swing.JFileChooser.APPROVE_OPTION$)
	       (let ((infile 
		      (java.io.FileReader. 
		       (set! current_file
			     (java.io.File. (.getCurrentDirectory fc) 
				      (.getName (.getSelectedFile fc)))))))
		 (.setText TA (readStreamIntoString infile))
		 (.validate TA)
		 (.close infile)
		 (extra-proc current_file))))
	 (lambda(err) (display (list "ERROR" err))(newline) #t))))
     
     ) ;;close letrec definitions

    (lambda (cmd . R)
      (case cmd
	((new) (new))
	((open) (open))
	((save) (save))
	((save-as) (save-as))
	((careful-save) (careful-save))
	((static-save) (static-save (first R)))
	((filechooser) fc)
	((get-display) TA)
	((set-procedure) (set! extra-proc (first R)))
	(else (display "FileUtil: Bad Command"))))))
