;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; KillRing.scm
;;
;; API:
;; (define K (make-kill-ring ))
;;
;;  (K 'add-kill STRING DATA)
;;  (K 'show-kill-win)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


(environment-import "jlib/Swing.scm" "Swing:")


(define (make-kill-ring)
  (letrec 
    (
     (getNth-kill (lambda (N L)
         (let loop ((N N) (L L))
             (if (or (<= N 0) (null? (rest L))) (first L) (loop (- N 1) (rest L))))))
     (kill-ring '(("" 0 0 0)))
     (kill-point 0)
     (kill-ta (Swing:textarea 10 50 Swing:yellow))
     (kill-label (Swing:label "0"))
     (kill-win #null)
     (show-kill (lambda (N)
                    (let ((M (cond ((>= N (length kill-ring)) (+ -1 (length kill-ring)))
                                   ((<= N 0) 0)
                                   (else N))))
                      (set! kill-point M) 
                      (let ((kill (getNth-kill kill-point kill-ring)))
                         (Swing:writeexpr kill-label (list kill-point (rest kill)))
                         (Swing:writestring kill-ta (first kill))))))

     (make-kill-win 
         (lambda()
               (Swing:window "kill-ring" (Swing:border 
                 (Swing:center kill-ta)
                 (Swing:north  (Swing:row 'center 'none kill-label))
                 (Swing:south (Swing:row 
                   (Swing:button "<<" (Swing:action(lambda(e) (show-kill 0))))
                   (Swing:button "<-" (Swing:action(lambda(e) (show-kill (+ -1 kill-point)))))
                   (Swing:button "|" (Swing:action(lambda(e) (show-kill kill-point))))
                   (Swing:button "->" (Swing:action(lambda(e) (show-kill (+ 1 kill-point)))))
                   (Swing:button ">>" (Swing:action(lambda(e) (show-kill (+ -1 (length kill-ring))))))
                 ))))))
    (msg-handler
      (lambda (cmd . R)
        (case cmd
          ((add-kill) (begin (set! kill-ring (cons R kill-ring))))
          ((show-kill-win) (show-kill 0) (.show kill-win) kill-win))))
    )
  (set! kill-win (make-kill-win))
  (.pack kill-win)

  msg-handler
))




