;; this adds the standard New,Open,Save,SaveAs,Quit menu items to
;; a file menu for a given window "win" and textarea "TA"

(environment-import "jlib/Swing.scm")

(define (set-accelerator K)
  (lambda(x) 
    (.setAccelerator x 
       (javax.swing.KeyStroke.getKeyStroke K java.awt.Event.CTRL_MASK$))))

(define (set-mnemonic K) (lambda(x) (.setMnemonic x K)))

(define (addFileMenuItems FileHandler FileMenu)
    (for-each (lambda(x) (.add FileMenu x))
      (list
       (menuitem "New" (set-mnemonic #'N')
	 (action (lambda(e) (FileHandler 'new))))
       (menuitem "Open" (set-mnemonic #'O')
         (action (lambda(e) (FileHandler 'open))))
       (menuitem "Save" (set-mnemonic #'S')
	 (action (lambda(e) (FileHandler 'careful-save))))
       (menuitem "Save As" (set-mnemonic #'A')
	  (action (lambda(e) (FileHandler 'save-as)))))))

(define (addEditMenuItems EditMenu TA)
  (for-each
   (lambda(x) (.add EditMenu x))
   (list (menuitem "Cut" (set-mnemonic #'U')
	       (action (lambda(e) (.cut TA))))
	 (menuitem "Copy" (set-mnemonic #'O') 
	       (action (lambda(e) (.copy TA))))
	 (menuitem "Paste" (set-mnemonic #'P') 
	       (action (lambda(e) (.paste TA))))
	 (menuitem "Select All" (set-mnemonic #'S') 
	       (action (lambda(e) (.selectAll TA)))))))

(define (addPopupMenu PopupMenu TA)
    (.add TA PopupMenu)
    (.addMouseListener TA (jsint.Listener. (lambda(e)
        (if (.isPopupTrigger e)
	    (begin (.requestFocusInWindow TA)
		   (.show PopupMenu (.getComponent e) (.getX e) (.getY e))))))))

(define (addFontMenu FontMenu TA)
  (let ((sizes '(2 8 9 10 11 12 14 16 18 20 22 24 26 28 36 48 72))
	 ;;(fonts (array->list (.getAllFonts 
         ;;       (java.awt.GraphicsEnvironment.getLocalGraphicsEnvironment))))
	(fonts (list (Courier 10) (CourierBold 10) (CourierItalic 10)
		     (TimesRoman 10) (TimesRomanBold 10) (TimesRomanItalic 10)
		     (Helvetica 10) (HelveticaBold 10) (HelveticaItalic 10)))
	(bgs (javax.swing.ButtonGroup.))
	(bgf (javax.swing.ButtonGroup.))
	(size-item (lambda(s)
	     (javax.swing.JRadioButtonMenuItem.
	      (groupscheme.platform.wrapper.ActionWrapper.
	       (.toString s)
	       (lambda R (.setFont TA (Courier 10))
		       (.setFont TA (.deriveFont (.getFont TA)
						   (.floatValue s))))))))
	(font-item (lambda(font)
	      (let ((item (javax.swing.JRadioButtonMenuItem.
			   (groupscheme.platform.wrapper.ActionWrapper.
			    (.getFontName font)
			    (lambda R (.setFont TA (java.awt.Font.
					   (.getFontName font)
					   java.awt.Font.PLAIN$
					   (.getSize (.getFont TA)))))))))
		;;(.setFont item (.deriveFont font 10f))
		(.setFont item font)
		item)))
	(smenu (menu "Size"))
	(nmenu (menu "Name"))
      );;close let
    (for-each (lambda(x) (.add smenu x) (.add bgs x)) (map size-item sizes))
    (for-each (lambda(x) (.add nmenu x) (.add bgf x)) (map font-item fonts))
    (.add FontMenu smenu)
    (.add FontMenu nmenu)))
