;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; Currently each binding must have a unique name even if it
;; corresponds to an existing action. Also, these KeyStrokes
;; are loosely based on an english keyborad (hint PowerBook G4)
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(import "javax.swing.text.DefaultEditorKit")

(define emacs
  (list
   ;; name                KeyStroke                 Action
   ;; ---                 ---------                 ------
   `(goto-line            (META L)                  goto-line)
   `(show-help            (CTRL H)                  show-help)
   `(undo                 (CTRL SHIFT MINUS)        emacs-undo)
   `(kill-line            (CTRL K)                  kill-line)
   `(kill-region          (META W)                  kill-region)
   `(yank                 (CTRL Y)                  yank)
   `(query-replace        ((ESCAPE) (SHIFT 5))      query-replace)
   `(isearch              (CTRL S)                  isearch)
   `(isearch-backward     (CTRL R)                  isearch-backward)

   `(beginning-of-line    (CTRL A)                  ,DefaultEditorKit.beginLineAction$)
   `(backward-char        (CTRL B)                  ,DefaultEditorKit.backwardAction$)
   `(delete-char          (CTRL D)                  ,DefaultEditorKit.deleteNextCharAction$)
   `(end-of-line          (CTRL E)                  ,DefaultEditorKit.endLineAction$)
   `(forward-char         (CTRL F)                  ,DefaultEditorKit.forwardAction$)
   `(next-line            (CTRL N)                  ,DefaultEditorKit.downAction$)
   `(open-line            (CTRL O)                  ,DefaultEditorKit.insertBreakAction$)
   `(previous-line        (CTRL P)                  ,DefaultEditorKit.upAction$)
   `(backward-page        ((CTRL X) (OPEN_BRACKET)) ,DefaultEditorKit.pageUpAction$)
                          ;; C-x ]
   `(forward-page         ((CTRL X) (CLOSE_BRACKET)) ,DefaultEditorKit.pageDownAction$)
   `(mark-whole-buffer    ((CTRL X) (H))            ,DefaultEditorKit.selectAllAction$)
                          ;; ESC <
   `(beginning-of-buffer  ((ESCAPE) (SHIFT COMMA)) ,DefaultEditorKit.beginAction$)
                          ;; ESC >
   `(end-of-buffer        ((ESCAPE) (SHIFT PERIOD)) ,DefaultEditorKit.endAction$)
   `(backward-word        ((ESCAPE) (B))            ,DefaultEditorKit.previousWordAction$)
   `(forward-word         ((ESCAPE) (F))            ,DefaultEditorKit.nextWordAction$)
  ) ;;close list
) ;;close define


(define windows
  (list
   ;; name                KeyStroke                 Action
   ;; ---                 ---------                 ------
   `(goto-line            (CTRL G)                  goto-line)
;   `(goto-line2           (META G)                  goto-line)
   `(show-help            (CTRL B)                  show-help)
;   `(show-help2           (META B)                  show-help)
   `(query-replace        (CTRL H)                  query-replace)
;   `(query-replace2       (CTRL SHIFT H)            query-replace)
   `(isearch              (CTRL F)                  isearch)
;   `(isearch1             (META F)                  isearch)
   `(isearch-backward     (CTRL SHIFT F)            isearch-backward)
;   `(isearch-backward2    (META SHIFT F)            isearch-backward)
  ) ;;close list
)