(define (kill-line bindings TC)
  (letrec
      (
;;     (copy-to-clipboard
;; 	(lambda (str)
;; 	  (let ((selection (java.awt.datatransfer.StringSelection. str)))
;; 	    (.setContents (.getSystemClipboard 
;; 			   (java.awt.Toolkit.getDefaultToolkit))
;; 			  selection selection))))
       (kill-line
	(lambda(act)
	  (let* ((doc (.getDocument TC))
		 (start (.getCaretPosition TC))
		 (line (.getLineOfOffset TC start))
		 (end (.getLineEndOffset TC line))
		 (text (.getText doc start (- end start)))
		 (len  (if (and (.endsWith text "\n") 
				(not (equal? (.trim text) "")))
			   (max (- (.length text) 1) 0)
			   (.length text)))
		 (killed (.substring text 0 len)))
	    (if (not (equal? killed ""))
		(begin (kill-ring bindings act killed)
		       ;;(copy-to-clipboard (kill-ring 'yank 0))
		       (.remove doc start len))))))
       (kill-listener
	(jsint.Listener. (lambda(e)
	   (if (and (= (.getID e) java.awt.event.KeyEvent.KEY_PRESSED$)
		    (not (or
		      (= (.getKeyCode e) java.awt.event.KeyEvent.VK_SHIFT$)
		      (= (.getKeyCode e) java.awt.event.KeyEvent.VK_ALT$)
		      (= (.getKeyCode e) java.awt.event.KeyEvent.VK_CONTROL$)
		      (= (.getKeyCode e) java.awt.event.KeyEvent.VK_META$)
		      (= (.getKeyCode e) java.awt.event.KeyEvent.VK_CAPS_LOCK$)
		      (= (.getKeyCode e) java.awt.event.KeyEvent.VK_NUM_LOCK$)
		))) ;;close or/not/and
	       (invoke (lambda ()
		 (if (< 1 (bindings 'tag 'killing))
		     (.removeKeyListener TC kill-listener)
		     (bindings 'tag 'killing (+ 1 (bindings 'tag 'killing))))))
        ))));;close if/lambda/jsint/kill
     );;close letrec definitions
    (bindings 'tag 'killing 2)
    (lambda R
	(if (< 1 (bindings 'tag 'killing))
	    (begin (.addKeyListener TC kill-listener)
		   (kill-line 'add))
	    (kill-line 'append))
	(bindings 'tag 'killing 0))))


;; Might want to switch .replaceSelection with .replaceRegion because of
;; possible selection loss when other users type in shared TC
(define (kill-region bindings TC)
  (lambda R 
    (kill-ring bindings 'add (.getSelectedText TC))
    (.replaceSelection TC "")))

    
(define (yank bindings TC)
  (lambda R
    (.insertString (.getDocument TC) 
		   (.getCaretPosition TC)
		   (kill-ring bindings 'yank 0)
		   #null)))

;; Might want to check to ensure that list-ref val is in range
;; and/or kill-ring is not null on yank
(define (kill-ring bindings act val)
  (case act
    ((add) (bindings 'tag 'kill-ring 
		     (append (list val) (bindings 'kill-ring))))
    ((append) (set-car! (bindings 'tag 'kill-ring)
			{[(first (bindings 'tag 'kill-ring))][val]}))
    ((yank) (list-ref (bindings 'tag 'kill-ring) val))))

(define (invoke lambda-expr)
  (java.awt.EventQueue.invokeLater
   (tryCatch 
    lambda-expr
    (lambda(e) 
      (javax.swing.JOptionPane.showMessageDialog
       #null {Search-Replace Invoke Error: [e]} "Bindings"
       javax.swing.JOptionPane.ERROR_MESSAGE$)))))