(environment-import "jlib/Swing.scm")

;;(define (keyboard-quit bindings TC)


(define (goto-line bindings TC)
  (lambda R
    (let ((_input (bindings 'tag 'buffer))
	  (_status (bindings 'tag 'status)))
      (.setEnabled _input #t)
      (writestring _status "Goto line:")
      (writestring _input "")
      (.requestFocusInWindow _input)
      (bindings 'add _input 'return-action '(ENTER)
        (lambda R
	  (tryCatch
	   (let ((line (readexpr _input)))
	     (.setCaretPosition 
	      TC (.getLineStartOffset 
		  TC (if (> line (.getLineCount TC))
			 (- (.getLineCount TC) 1)
			 (if (<= line 0)
			     0
			     (- line 1)))))
	     (bindings 'remove _input 'return-action)
	     (writestring _status "")
	     (writestring _input "")
	     (.setEnabled _input #f)
	     (.requestFocusInWindow TC))
	   (lambda (e) (writestring _input ""))))))))


(define (emacs-undo bindings TC)
  (let* ((edits '())
	 (index -1)
	 (document (.getDocument TC))
	 (undoable (jsint.Listener. (lambda(e)
	     (set! edits (cons (list 'undo (.getEdit e)) edits))
	     (set! index 0)))))
    (.addUndoableEditListener document undoable)
    (lambda R
      (if (< index (length edits))
	  (let ((flip (lambda (x) (case x ((undo) 'redo) (else 'undo))))
		(edit (list-ref edits index)))
	    (if (eq? 'undo (first edit))
		(.undo (second edit))
		(.redo (second edit)))
	    (set! edits (cons `(,(flip (first edit)) ,(second edit)) edits))
	    (set! index (+ index 2)))))))

; (define (UndoManager command TC)
;   (letrec
;     ((manager (javax.swing.undo.UndoManager.))
;      (document (.getDocument TC))
;      (undoable-listener
;       (jsint.Listener. (lambda(e)
; 	 (.addEdit manager (.getEdit e))))))

;     (.addUndoableEditListener document undoable-listener)
;     (case command
;       ((undo)
;        (lambda R
; 	 (if (.canUndo manager)
; 	     (.undo manager)
; 	     (display "can't undo\n"))))
;       ((redo)
;        (lambda R
; 	 (if (.canRedo manager)
; 	     (.redo manager)
; 	     (display "can't redo\n")))))))


(define (show-help bindings TA)
  (letrec 
   ((cmdTA (textarea 15 40))
    (win
     (window "Bindings"
      (col
       (scrollpane (textarea 7 40 yellow
	{[{To add a binding, in the textarea below, write a list that contains}
	  {\na name, a KeyStroke or list of KeyStrokes, and an action.\n}
	  {  Example:\n}
	  {   (binding-name ((CTRL X) (E))\n}
	  {     (lambda R (display "add binding example")))\n}
	  {  Example:\n}
	  {   (binding-name ((CTRL X) (E))\n}
	  {     DefaultEditorKit.insertTabAction$)\n}
	  {  Example:\n}
	  {   (binding-name ((CTRL X) (E))\n}
	  {     'goto-line)\n}
	  {  Example:\n}
	  {   (binding-name ((CTRL X) (E))\n}
	  {     "copy-to-clipboard")\n\n}
	  {To remove a binding simply write the name of the binding below.}]}
	   (lambda(this) (.setEditable this #f))))
	(scrollpane cmdTA)
	(row 
	 (button "Add" (action(lambda(e)
	    (let* ((binding (readexpr cmdTA))
		   (name (first binding))
		   (ksl (second binding))
		   (act (eval (third binding))))
	      (bindings 'add TA name ksl act)))))
	 (button "Remove" (action(lambda(e) 
            (bindings 'remove TA (readexpr cmdTA)))))
	 (button "Display" (action(lambda(e)
	    (writestring cmdTA "Current Bindings:\n")
	    (map (lambda(x)			
		   (appendlnstring cmdTA {   [(first x)] ==> [(second x)]}))
		 (bindings 'get 'list)))))
	 (button "Supported" (action(lambda(e)
	    (writestring cmdTA "Supported Bindings:\n")
	    (map (lambda(x)			
		   (appendlnstring cmdTA {   [x]}))
		 (bindings 'get 'supported)))))

	 (button "Clear" (action(lambda(e) (writestring cmdTA ""))))
	 (button "Close" (action(lambda(e) (.hide win)))))))))
   (lambda R
     (writestring cmdTA "")
     (.pack win) (.show win))))
