package groupscheme.platform.wrapper;

import javax.swing.ListCellRenderer;
import javax.swing.JList;
import javax.swing.table.TableCellRenderer;
import javax.swing.JTable;
import java.awt.Component;

import jscheme.JS;
import jsint.Procedure;

public class CellRendererWrapper implements ListCellRenderer, TableCellRenderer {

     Procedure getComponent;

     public CellRendererWrapper(Procedure getComponent) {
	 this.getComponent = getComponent;
     }
     public Component getListCellRendererComponent
	 (JList list, Object value, int index,
	  boolean isSelected, boolean cellHasFocus) {
	 if (getComponent != null)
	     return (Component) 
		 JS.call(getComponent, list, value, new Integer(index), 
			 new Boolean(isSelected), new Boolean(cellHasFocus));
	 else return null;
     }

     public Component getTableCellRendererComponent
	 (JTable table, Object value, boolean isSelected, 
	  boolean cellHasFocus, int row, int col) {
	 if (getComponent != null)
	     return (Component) 
		 JS.call(getComponent, table, value,
			 new Boolean(isSelected), new Boolean(cellHasFocus), 
			 new Integer(row), new Integer(col));
	 else return null;
     }
 }